import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudComputeBmsFlavorsV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#id DataOpentelekomcloudComputeBmsFlavorsV2#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#min_disk DataOpentelekomcloudComputeBmsFlavorsV2#min_disk}.
     *
     * @stability stable
     */
    readonly minDisk?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#min_ram DataOpentelekomcloudComputeBmsFlavorsV2#min_ram}.
     *
     * @stability stable
     */
    readonly minRam?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#name DataOpentelekomcloudComputeBmsFlavorsV2#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#region DataOpentelekomcloudComputeBmsFlavorsV2#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#sort_dir DataOpentelekomcloudComputeBmsFlavorsV2#sort_dir}.
     *
     * @stability stable
     */
    readonly sortDir?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html#sort_key DataOpentelekomcloudComputeBmsFlavorsV2#sort_key}.
     *
     * @stability stable
     */
    readonly sortKey?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html opentelekomcloud_compute_bms_flavors_v2}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudComputeBmsFlavorsV2 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_bms_flavors_v2.html opentelekomcloud_compute_bms_flavors_v2} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudComputeBmsFlavorsV2Config);
    /**
     * @stability stable
     */
    get disk(): number;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    set id(value: string);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    private _minDisk?;
    /**
     * @stability stable
     */
    get minDisk(): number;
    /**
     * @stability stable
     */
    set minDisk(value: number);
    /**
     * @stability stable
     */
    resetMinDisk(): void;
    /**
     * @stability stable
     */
    get minDiskInput(): number | undefined;
    private _minRam?;
    /**
     * @stability stable
     */
    get minRam(): number;
    /**
     * @stability stable
     */
    set minRam(value: number);
    /**
     * @stability stable
     */
    resetMinRam(): void;
    /**
     * @stability stable
     */
    get minRamInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get ram(): number;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    /**
     * @stability stable
     */
    get rxTxFactor(): number;
    private _sortDir?;
    /**
     * @stability stable
     */
    get sortDir(): string;
    /**
     * @stability stable
     */
    set sortDir(value: string);
    /**
     * @stability stable
     */
    resetSortDir(): void;
    /**
     * @stability stable
     */
    get sortDirInput(): string | undefined;
    private _sortKey?;
    /**
     * @stability stable
     */
    get sortKey(): string;
    /**
     * @stability stable
     */
    set sortKey(value: string);
    /**
     * @stability stable
     */
    resetSortKey(): void;
    /**
     * @stability stable
     */
    get sortKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get swap(): number;
    /**
     * @stability stable
     */
    get vcpus(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
