import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudDcsMaintainwindowV1Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1.html#begin DataOpentelekomcloudDcsMaintainwindowV1#begin}.
     *
     * @stability stable
     */
    readonly begin?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1.html#default DataOpentelekomcloudDcsMaintainwindowV1#default}.
     *
     * @stability stable
     */
    readonly default?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1.html#end DataOpentelekomcloudDcsMaintainwindowV1#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1.html#seq DataOpentelekomcloudDcsMaintainwindowV1#seq}.
     *
     * @stability stable
     */
    readonly seq?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1.html opentelekomcloud_dcs_maintainwindow_v1}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudDcsMaintainwindowV1 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/dcs_maintainwindow_v1.html opentelekomcloud_dcs_maintainwindow_v1} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudDcsMaintainwindowV1Config);
    private _begin?;
    /**
     * @stability stable
     */
    get begin(): string;
    /**
     * @stability stable
     */
    set begin(value: string);
    /**
     * @stability stable
     */
    resetBegin(): void;
    /**
     * @stability stable
     */
    get beginInput(): string | undefined;
    private _default?;
    /**
     * @stability stable
     */
    get default(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set default(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDefault(): void;
    /**
     * @stability stable
     */
    get defaultInput(): boolean | cdktf.IResolvable | undefined;
    private _end?;
    /**
     * @stability stable
     */
    get end(): string;
    /**
     * @stability stable
     */
    set end(value: string);
    /**
     * @stability stable
     */
    resetEnd(): void;
    /**
     * @stability stable
     */
    get endInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _seq?;
    /**
     * @stability stable
     */
    get seq(): number;
    /**
     * @stability stable
     */
    set seq(value: number);
    /**
     * @stability stable
     */
    resetSeq(): void;
    /**
     * @stability stable
     */
    get seqInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
