import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkingNetworkV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#admin_state_up NetworkingNetworkV2#admin_state_up}.
     *
     * @stability stable
     */
    readonly adminStateUp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#name NetworkingNetworkV2#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#region NetworkingNetworkV2#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#shared NetworkingNetworkV2#shared}.
     *
     * @stability stable
     */
    readonly shared?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#tenant_id NetworkingNetworkV2#tenant_id}.
     *
     * @stability stable
     */
    readonly tenantId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#value_specs NetworkingNetworkV2#value_specs}.
     *
     * @stability stable
     */
    readonly valueSpecs?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * segments block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#segments NetworkingNetworkV2#segments}
     *
     * @stability stable
     */
    readonly segments?: NetworkingNetworkV2Segments[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#timeouts NetworkingNetworkV2#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: NetworkingNetworkV2Timeouts;
}
/**
 * @stability stable
 */
export interface NetworkingNetworkV2Segments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#network_type NetworkingNetworkV2#network_type}.
     *
     * @stability stable
     */
    readonly networkType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#physical_network NetworkingNetworkV2#physical_network}.
     *
     * @stability stable
     */
    readonly physicalNetwork?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#segmentation_id NetworkingNetworkV2#segmentation_id}.
     *
     * @stability stable
     */
    readonly segmentationId?: number;
}
export declare function networkingNetworkV2SegmentsToTerraform(struct?: NetworkingNetworkV2Segments): any;
/**
 * @stability stable
 */
export interface NetworkingNetworkV2Timeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#create NetworkingNetworkV2#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html#delete NetworkingNetworkV2#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function networkingNetworkV2TimeoutsToTerraform(struct?: NetworkingNetworkV2TimeoutsOutputReference | NetworkingNetworkV2Timeouts): any;
/**
 * @stability stable
 */
export declare class NetworkingNetworkV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): NetworkingNetworkV2Timeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: NetworkingNetworkV2Timeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html opentelekomcloud_networking_network_v2}.
 *
 * @stability stable
 */
export declare class NetworkingNetworkV2 extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/networking_network_v2.html opentelekomcloud_networking_network_v2} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: NetworkingNetworkV2Config);
    private _adminStateUp?;
    /**
     * @stability stable
     */
    get adminStateUp(): string;
    /**
     * @stability stable
     */
    set adminStateUp(value: string);
    /**
     * @stability stable
     */
    resetAdminStateUp(): void;
    /**
     * @stability stable
     */
    get adminStateUpInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _shared?;
    /**
     * @stability stable
     */
    get shared(): string;
    /**
     * @stability stable
     */
    set shared(value: string);
    /**
     * @stability stable
     */
    resetShared(): void;
    /**
     * @stability stable
     */
    get sharedInput(): string | undefined;
    private _tenantId?;
    /**
     * @stability stable
     */
    get tenantId(): string;
    /**
     * @stability stable
     */
    set tenantId(value: string);
    /**
     * @stability stable
     */
    resetTenantId(): void;
    /**
     * @stability stable
     */
    get tenantIdInput(): string | undefined;
    private _valueSpecs?;
    /**
     * @stability stable
     */
    get valueSpecs(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set valueSpecs(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetValueSpecs(): void;
    /**
     * @stability stable
     */
    get valueSpecsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _segments?;
    /**
     * @stability stable
     */
    get segments(): NetworkingNetworkV2Segments[];
    /**
     * @stability stable
     */
    set segments(value: NetworkingNetworkV2Segments[]);
    /**
     * @stability stable
     */
    resetSegments(): void;
    /**
     * @stability stable
     */
    get segmentsInput(): NetworkingNetworkV2Segments[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): NetworkingNetworkV2TimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: NetworkingNetworkV2Timeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): NetworkingNetworkV2Timeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
