import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SwrOrganizationV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2.html#name SwrOrganizationV2#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2.html#timeouts SwrOrganizationV2#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: SwrOrganizationV2Timeouts;
}
/**
 * @stability stable
 */
export interface SwrOrganizationV2Timeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2.html#create SwrOrganizationV2#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2.html#delete SwrOrganizationV2#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function swrOrganizationV2TimeoutsToTerraform(struct?: SwrOrganizationV2TimeoutsOutputReference | SwrOrganizationV2Timeouts): any;
/**
 * @stability stable
 */
export declare class SwrOrganizationV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SwrOrganizationV2Timeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SwrOrganizationV2Timeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2.html opentelekomcloud_swr_organization_v2}.
 *
 * @stability stable
 */
export declare class SwrOrganizationV2 extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/swr_organization_v2.html opentelekomcloud_swr_organization_v2} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SwrOrganizationV2Config);
    /**
     * @stability stable
     */
    get auth(): number;
    /**
     * @stability stable
     */
    get creatorName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get organizationId(): number;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): SwrOrganizationV2TimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: SwrOrganizationV2Timeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SwrOrganizationV2Timeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
