import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpnaasIkePolicyV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#auth_algorithm VpnaasIkePolicyV2#auth_algorithm}.
     *
     * @stability stable
     */
    readonly authAlgorithm?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#description VpnaasIkePolicyV2#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#encryption_algorithm VpnaasIkePolicyV2#encryption_algorithm}.
     *
     * @stability stable
     */
    readonly encryptionAlgorithm?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#ike_version VpnaasIkePolicyV2#ike_version}.
     *
     * @stability stable
     */
    readonly ikeVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#name VpnaasIkePolicyV2#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#pfs VpnaasIkePolicyV2#pfs}.
     *
     * @stability stable
     */
    readonly pfs?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#phase1_negotiation_mode VpnaasIkePolicyV2#phase1_negotiation_mode}.
     *
     * @stability stable
     */
    readonly phase1NegotiationMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#region VpnaasIkePolicyV2#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#tenant_id VpnaasIkePolicyV2#tenant_id}.
     *
     * @stability stable
     */
    readonly tenantId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#value_specs VpnaasIkePolicyV2#value_specs}.
     *
     * @stability stable
     */
    readonly valueSpecs?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * lifetime block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#lifetime VpnaasIkePolicyV2#lifetime}
     *
     * @stability stable
     */
    readonly lifetime?: VpnaasIkePolicyV2Lifetime[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#timeouts VpnaasIkePolicyV2#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VpnaasIkePolicyV2Timeouts;
}
/**
 * @stability stable
 */
export interface VpnaasIkePolicyV2Lifetime {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#units VpnaasIkePolicyV2#units}.
     *
     * @stability stable
     */
    readonly units?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#value VpnaasIkePolicyV2#value}.
     *
     * @stability stable
     */
    readonly value?: number;
}
export declare function vpnaasIkePolicyV2LifetimeToTerraform(struct?: VpnaasIkePolicyV2Lifetime): any;
/**
 * @stability stable
 */
export interface VpnaasIkePolicyV2Timeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html#create VpnaasIkePolicyV2#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
export declare function vpnaasIkePolicyV2TimeoutsToTerraform(struct?: VpnaasIkePolicyV2TimeoutsOutputReference | VpnaasIkePolicyV2Timeouts): any;
/**
 * @stability stable
 */
export declare class VpnaasIkePolicyV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): VpnaasIkePolicyV2Timeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: VpnaasIkePolicyV2Timeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html opentelekomcloud_vpnaas_ike_policy_v2}.
 *
 * @stability stable
 */
export declare class VpnaasIkePolicyV2 extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/vpnaas_ike_policy_v2.html opentelekomcloud_vpnaas_ike_policy_v2} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: VpnaasIkePolicyV2Config);
    private _authAlgorithm?;
    /**
     * @stability stable
     */
    get authAlgorithm(): string;
    /**
     * @stability stable
     */
    set authAlgorithm(value: string);
    /**
     * @stability stable
     */
    resetAuthAlgorithm(): void;
    /**
     * @stability stable
     */
    get authAlgorithmInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _encryptionAlgorithm?;
    /**
     * @stability stable
     */
    get encryptionAlgorithm(): string;
    /**
     * @stability stable
     */
    set encryptionAlgorithm(value: string);
    /**
     * @stability stable
     */
    resetEncryptionAlgorithm(): void;
    /**
     * @stability stable
     */
    get encryptionAlgorithmInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ikeVersion?;
    /**
     * @stability stable
     */
    get ikeVersion(): string;
    /**
     * @stability stable
     */
    set ikeVersion(value: string);
    /**
     * @stability stable
     */
    resetIkeVersion(): void;
    /**
     * @stability stable
     */
    get ikeVersionInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _pfs?;
    /**
     * @stability stable
     */
    get pfs(): string;
    /**
     * @stability stable
     */
    set pfs(value: string);
    /**
     * @stability stable
     */
    resetPfs(): void;
    /**
     * @stability stable
     */
    get pfsInput(): string | undefined;
    private _phase1NegotiationMode?;
    /**
     * @stability stable
     */
    get phase1NegotiationMode(): string;
    /**
     * @stability stable
     */
    set phase1NegotiationMode(value: string);
    /**
     * @stability stable
     */
    resetPhase1NegotiationMode(): void;
    /**
     * @stability stable
     */
    get phase1NegotiationModeInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _tenantId?;
    /**
     * @stability stable
     */
    get tenantId(): string;
    /**
     * @stability stable
     */
    set tenantId(value: string);
    /**
     * @stability stable
     */
    resetTenantId(): void;
    /**
     * @stability stable
     */
    get tenantIdInput(): string | undefined;
    private _valueSpecs?;
    /**
     * @stability stable
     */
    get valueSpecs(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set valueSpecs(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetValueSpecs(): void;
    /**
     * @stability stable
     */
    get valueSpecsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _lifetime?;
    /**
     * @stability stable
     */
    get lifetime(): VpnaasIkePolicyV2Lifetime[];
    /**
     * @stability stable
     */
    set lifetime(value: VpnaasIkePolicyV2Lifetime[]);
    /**
     * @stability stable
     */
    resetLifetime(): void;
    /**
     * @stability stable
     */
    get lifetimeInput(): VpnaasIkePolicyV2Lifetime[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): VpnaasIkePolicyV2TimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: VpnaasIkePolicyV2Timeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VpnaasIkePolicyV2Timeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
